package models

import (
	"github.com/rs/zerolog"
	"gopkg.in/dgrijalva/jwt-go.v3"
)

// Principal holds the current user principals that were extracted from
// the JWT.
type Principal struct {
	jwt.StandardClaims

	IsAdmin               bool
	EnabledRequestLogging bool
}

// MarshalZerologObject implements the zerolog.LogObjectMarshaler interface.
func (p *Principal) MarshalZerologObject(e *zerolog.Event) {
	e.
		Str("id", p.Subject).
		Bool("is-admin", p.IsAdmin).
		Bool("enable-request-logging", p.EnabledRequestLogging)
}
