// Code generated by go-swagger; DO NOT EDIT.

package user_management

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"orus.io/orus-io/rednerd/models"
)

// UserPasswordSetHandlerFunc turns a function with the right signature into a user password set handler
type UserPasswordSetHandlerFunc func(UserPasswordSetParams, *models.Principal) middleware.Responder

// Handle executing the request and returning a response
func (fn UserPasswordSetHandlerFunc) Handle(params UserPasswordSetParams, principal *models.Principal) middleware.Responder {
	return fn(params, principal)
}

// UserPasswordSetHandler interface for that can handle valid user password set params
type UserPasswordSetHandler interface {
	Handle(UserPasswordSetParams, *models.Principal) middleware.Responder
}

// NewUserPasswordSet creates a new http.Handler for the user password set operation
func NewUserPasswordSet(ctx *middleware.Context, handler UserPasswordSetHandler) *UserPasswordSet {
	return &UserPasswordSet{Context: ctx, Handler: handler}
}

/*UserPasswordSet swagger:route POST /v1/user/{username}/password user-management userPasswordSet

UserPasswordSet user password set API

*/
type UserPasswordSet struct {
	Context *middleware.Context
	Handler UserPasswordSetHandler
}

func (o *UserPasswordSet) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewUserPasswordSetParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal *models.Principal
	if uprinc != nil {
		principal = uprinc.(*models.Principal) // this is really a models.Principal, I promise
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}

// UserPasswordSetBody user password set body
//
// swagger:model UserPasswordSetBody
type UserPasswordSetBody struct {

	// The user new password
	Password string `json:"password,omitempty"`
}

// Validate validates this user password set body
func (o *UserPasswordSetBody) Validate(formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (o *UserPasswordSetBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *UserPasswordSetBody) UnmarshalBinary(b []byte) error {
	var res UserPasswordSetBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
